(**************************************************************************
* BlockCAD, a program for building with Lego like blocks on the computer
* Copyright (C) 1998  Anders Isaksson
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
* -------------------------------------------------------------------------
* I hope You send me a copy of any important changes/additions You do.
*
* E-mail: isaksson.etuna@ebox.tninet.se
*
**************************************************************************)

unit AboutBLK;

interface

uses
  Windows, Controls, ExtCtrls, Classes, Forms, RXCtrls, Graphics
  ;

type
  TAbout = class(TForm)
    RxLabel1: TRxLabel;
    Bevel1: TBevel;
    RxSpeedButton2: TRxSpeedButton;
    RxLabel2: TRxLabel;
    RxLabel3: TRxLabel;
    RxLabel4: TRxLabel;
    RxLabel6: TRxLabel;
    RxLabel7: TRxLabel;
    RxSpeedButton1: TRxSpeedButton;
    SecretPanel1: TSecretPanel;
    RxLabel5: TRxLabel;
    RxSpeedButton3: TRxSpeedButton;
    PaintBoxAbout: TPaintBox;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure RxLabel4Click(Sender: TObject);
    procedure RxLabel5Click(Sender: TObject);
    procedure RxSpeedButton1Click(Sender: TObject);
    procedure RxSpeedButton3Click(Sender: TObject);
    procedure PaintBoxAboutPaint(Sender: TObject);
  private
    { Private declarations }
    function GetVersion: string;
  public
    { Public declarations }
    property Version: string read GetVersion;
  end;

var
  About             : TAbout;

implementation

{$R *.DFM}

uses ShellApi, LCadPc2;

var
  fVersion          : string = '3.19';
  fDate             : string = '2005-01-06';
  fMail             : string = 'blockcad@telia.com';
  fHome             : string = 'http://w1.161.telia.com/~u16122508/proglego.htm';
  fInstr            : string = 'instruct.htm';

function TAbout.GetVersion: string;
begin
  Result := fVersion;
end;

procedure TAbout.FormCreate(Sender: TObject);
begin
  RxLabel2.Caption := 'Version ' + fVersion;
  RxLabel3.Caption := fDate;
  RxLabel4.Caption := fHome;
  RxLabel5.Caption := fMail;
  if Pos('CDS', fVersion) <> 0 then
    RxLabel1.Visible := False;
end;

procedure TAbout.RxLabel4Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(fHome), nil, nil, SW_SHOWNORMAL);
end;

procedure TAbout.RxLabel5Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar('mailto:' + fMail), nil, nil, SW_SHOWNORMAL);
end;

procedure TAbout.RxSpeedButton1Click(Sender: TObject);
begin
  with SecretPanel1 do
    if Visible = True then begin
      Active := False;
      Visible := False;
    end
    else begin
      Active := True;
      Visible := True;
    end;
end;

procedure TAbout.RxSpeedButton3Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar('file://' + ExeLib + fInstr), nil, nil, SW_SHOWNORMAL);
end;

procedure TAbout.PaintBoxAboutPaint(Sender: TObject);
begin
  if Pos('CDS', fVersion) <> 0 then
    with PaintBoxAbout.Canvas do begin
      TextOut(106, 10, 'This is a...');
      Draw(10, 30, Image1.Picture.BitMap);
      TextOut(104, 120, 'Special Edition');
      TextOut(130, 134, 'by');
      TextOut(100, 148, 'Anders Isaksson');
    end;
end;

end.

