unit Reorder;

interface

uses
  Windows, StdCtrls, Buttons, Controls, Classes, Forms, RXCtrls
  ;

type
  TfrmReorder = class(TForm)
    lbRight: TListBox;
    RxSpeedButton3: TRxSpeedButton;
    RxSpeedButton4: TRxSpeedButton;
    btnCancel: TBitBtn;
    btnOK: TBitBtn;
    procedure RxSpeedButton3Click(Sender: TObject);
    procedure RxSpeedButton4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    PageNames: TStringList;
    Pages: TStringList;
    PgHeight: TList;
    PgScale: TList;
    procedure CopyIn;
    procedure CopyOut;
  public
    { Public declarations }
    procedure Execute;
  end;

var
  frmReorder        : TfrmReorder;

implementation

uses main;

{$R *.DFM}

procedure AssignList(ld, ls: TList);
var
  i                 : integer;
begin
  ld.Clear;
  for i := 0 to Pred(ls.Count) do
    ld.Add(ls[i]);
end;

procedure TfrmReorder.CopyIn;
//var i: integer;
begin
  PageNames.Assign(MainForm.PageNames);
  PageNames.Delete(0);
  Pages.Assign(MainForm.Pages);
  AssignList(PgHeight, MainForm.PgHeight);
  AssignList(PgScale, MainForm.PgScale);
end;

procedure TfrmReorder.CopyOut;
begin
  PageNames.Insert(0, '<Recently used>');
  MainForm.PageNames.Assign(PageNames);
  MainForm.Pages.Assign(Pages);
  AssignList(MainForm.PgHeight, PgHeight);
  AssignList(MainForm.PgScale, PgScale);
end;

procedure TfrmReorder.Execute;
begin
  {fill up local data}
  CopyIn;
  lbRight.Items.Assign(PageNames);
  if ShowModal = mrOK then begin
    {store local data globally}
    CopyOut;
  end
end;

procedure TfrmReorder.RxSpeedButton3Click(Sender: TObject);
var
  i                 : integer;
begin
  if lbRight.ItemIndex > 0 then begin
    i := lbRight.ItemIndex;
    lbRight.Items.Move(i, Pred(i));
    PageNames.Move(i, Pred(i));
    Pages.Move(i, Pred(i));
    PgHeight.Move(i, Pred(i));
    PgScale.Move(i, Pred(i));
    lbRight.ItemIndex := Pred(i);
  end
end;

procedure TfrmReorder.RxSpeedButton4Click(Sender: TObject);
var
  i                 : integer;
begin
  if lbRight.ItemIndex < lbRight.Items.Count then begin
    i := lbRight.ItemIndex;
    lbRight.Items.Move(i, Succ(i));
    PageNames.Move(i, Succ(i));
    Pages.Move(i, Succ(i));
    PgHeight.Move(i, Succ(i));
    PgScale.Move(i, Succ(i));
    lbRight.ItemIndex := Succ(i);
  end
end;

procedure TfrmReorder.FormCreate(Sender: TObject);
begin
  PageNames := TStringList.Create;
  Pages := TStringList.Create;
  PgHeight := TList.Create;
  PgScale := TList.Create;
end;

procedure TfrmReorder.FormDestroy(Sender: TObject);
begin
  PageNames.Free;
  Pages.Free;
  PgHeight.Free;
  PgScale.Free;
end;

end.
