unit SetLight;

interface

uses
  Windows, StdCtrls, Buttons, Controls, Classes, Forms, RXSpin
  ;

type
  TfrmSetLight = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    rxsX: TRxSpinEdit;
    rxsY: TRxSpinEdit;
    rxsZ: TRxSpinEdit;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    chkPreview: TCheckBox;
    procedure rxsZChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSetLight       : TfrmSetLight;

function Execute: Boolean;

implementation

uses
  Lcadpc2, Main
  ;

{$R *.DFM}

function Execute: Boolean;
begin
  with frmSetLight do begin
    rxsX.AsInteger := Light.x;
    rxsY.AsInteger := Light.y;
    rxsZ.AsInteger := Light.z;
    Result := ShowModal = mrOK;
    if Result then begin
      Light.x := rxsX.AsInteger;
      Light.y := rxsY.AsInteger;
      Light.z := rxsZ.AsInteger;
    end
  end
end;

procedure TfrmSetLight.rxsZChange(Sender: TObject);
var
  SaveLight         : TPoint3D;
begin
  if chkPreview.Checked then begin
    SaveLight := Lcadpc2.Light;
    Light.x := rxsX.AsInteger;
    Light.y := rxsY.AsInteger;
    Light.z := rxsZ.AsInteger;
    Lcadpc2.CalcStandardShades;
    MainForm.RedrawPicture(nil);
    Application.ProcessMessages;
    Lcadpc2.Light := SaveLight;
  end
end;

end.
